/*===========================================================================
 *
 * File:	ObRefrrecord.CPP
 * Author:	Dave Humphrey (uesp@sympatico.ca)
 * Created On:	April 12, 2006
 *
 * Implements the CObRefrRecord class for reference type records.
 *
 *=========================================================================*/

	/* Include Files */
#include "obrefrrecord.h"
#include "../obrecordhandler.h"
#include "../groups/obformidgroup.h"
#include "obcellrecord.h"
#include "obwrldrecord.h"


/*===========================================================================
 *
 * Begin Subrecord Creation Array
 *
 *=========================================================================*/
BEGIN_OBSUBRECCREATE(CObRefrRecord, CObIdRecord)
	DEFINE_OBSUBRECCREATE(OB_NAME_NAME, CObFormidSubrecord::Create)
	DEFINE_OBSUBRECCREATE(OB_NAME_FULL, CObFullSubrecord::Create)
	DEFINE_OBSUBRECCREATE(OB_NAME_DATA, CObRefrDataSubrecord::Create)
	DEFINE_OBSUBRECCREATE(OB_NAME_XTEL, CObXtelSubrecord::Create)
	DEFINE_OBSUBRECCREATE(OB_NAME_TNAM, CObWordSubrecord::Create)
	DEFINE_OBSUBRECCREATE(OB_NAME_XTRG, CObFormidSubrecord::Create)
	DEFINE_OBSUBRECCREATE(OB_NAME_XRTM, CObFormidSubrecord::Create)
	DEFINE_OBSUBRECCREATE(OB_NAME_XLOC, CObXlocSubrecord::Create)
	DEFINE_OBSUBRECCREATE(OB_NAME_XOWN, CObFormidSubrecord::Create)
	DEFINE_OBSUBRECCREATE(OB_NAME_XESP, CObXespSubrecord::Create)
	DEFINE_OBSUBRECCREATE(OB_NAME_XGLB, CObFormidSubrecord::Create)
	DEFINE_OBSUBRECCREATE(OB_NAME_XPCI, CObFormidSubrecord::Create)
END_OBSUBRECCREATE()
/*===========================================================================
 *		End of Subrecord Creation Array
 *=========================================================================*/


/*===========================================================================
 *
 * Begin CObRefrRecord Field Map
 *
 *=========================================================================*/
BEGIN_OBFIELDMAP(CObRefrRecord, CObIdRecord)
	ADD_OBFIELDMAP("Item Name",	 OB_FIELD_ITEMNAME,	  0, &CObRefrRecord::GetFieldItemName,		&CObRefrRecord::SetFieldItemName,&CObRefrRecord::CompareFieldItemName)
	ADD_OBFIELDMAP("LocationX",	 OB_FIELD_LOCATIONX,	  0, &CObRefrRecord::GetFieldLocationX,		NULL,				&CObRefrRecord::CompareFieldLocationX)
	ADD_OBFIELDMAP("LocationY",	 OB_FIELD_LOCATIONY,	  0, &CObRefrRecord::GetFieldLocationY,		NULL,				&CObRefrRecord::CompareFieldLocationY)
	ADD_OBFIELDMAP("LocationZ",	 OB_FIELD_LOCATIONZ,	  0, &CObRefrRecord::GetFieldLocationZ,		NULL,				&CObRefrRecord::CompareFieldLocationZ)
	ADD_OBFIELDMAP("AngleX",	 OB_FIELD_ANGLEX,	  0, &CObRefrRecord::GetFieldAngleX,		NULL,				&CObRefrRecord::CompareFieldAngleX)
	ADD_OBFIELDMAP("AngleY",	 OB_FIELD_ANGLEY,	  0, &CObRefrRecord::GetFieldAngleY,		NULL,				&CObRefrRecord::CompareFieldAngleY)
	ADD_OBFIELDMAP("AngleZ",	 OB_FIELD_ANGLEZ,	  0, &CObRefrRecord::GetFieldAngleZ,		NULL,				&CObRefrRecord::CompareFieldAngleZ)
	ADD_OBFIELDMAP("TeleportFormID", OB_FIELD_TELEPORTFORMID, 0, &CObRefrRecord::GetFieldTeleportFormID,	NULL,				&CObRefrRecord::CompareFieldTeleportFormID)
	ADD_OBFIELDMAP("TeleportName",	 OB_FIELD_TELEPORTNAME,   0, &CObRefrRecord::GetFieldTeleportName,	NULL,				NULL)
	ADD_OBFIELDMAP("TeleportLocX",	 OB_FIELD_TELEPORTLOCX,   0, &CObRefrRecord::GetFieldTeleportLocX,	NULL,				&CObRefrRecord::CompareFieldTeleportLocX)
	ADD_OBFIELDMAP("TeleportLocY",	 OB_FIELD_TELEPORTLOCY,   0, &CObRefrRecord::GetFieldTeleportLocY,	NULL,				&CObRefrRecord::CompareFieldTeleportLocY)
	ADD_OBFIELDMAP("TeleportLocZ",	 OB_FIELD_TELEPORTLOCZ,   0, &CObRefrRecord::GetFieldTeleportLocZ,	NULL,				&CObRefrRecord::CompareFieldTeleportLocZ)
	ADD_OBFIELDMAP("TeleportAngleX", OB_FIELD_TELEPORTANGLEX, 0, &CObRefrRecord::GetFieldTeleportAngleX,	NULL,				&CObRefrRecord::CompareFieldTeleportAngleX)
	ADD_OBFIELDMAP("TeleportAngleY", OB_FIELD_TELEPORTANGLEY, 0, &CObRefrRecord::GetFieldTeleportAngleY,	NULL,				&CObRefrRecord::CompareFieldTeleportAngleY)
	ADD_OBFIELDMAP("TeleportAngleZ", OB_FIELD_TELEPORTANGLEZ, 0, &CObRefrRecord::GetFieldTeleportAngleZ,	NULL,				&CObRefrRecord::CompareFieldTeleportAngleZ)
	ADD_OBFIELDMAP("WorldSpace",     OB_FIELD_WORLDSPACE,     0, &CObRefrRecord::GetFieldWorldSpace,	NULL,				NULL)
	ADD_OBFIELDMAP("MarkerType",     OB_FIELD_MARKERTYPE,     0, &CObRefrRecord::GetFieldMarkerType,	NULL,				&CObRefrRecord::CompareFieldMarkerType)
	ADD_OBFIELDMAP("MarkerTypeID",   OB_FIELD_MARKERTYPEID,   0, &CObRefrRecord::GetFieldMarkerTypeID,	NULL,				&CObRefrRecord::CompareFieldMarkerTypeID)
	ADD_OBFIELDMAP("BaseFormID",	 OB_FIELD_BASEFORMID,	  0, &CObRefrRecord::GetFieldBaseFormID,	NULL,				&CObRefrRecord::CompareFieldBaseFormID)
	ADD_OBFIELDMAP("BaseEditorID",	 OB_FIELD_BASEEDITORID,	  0, &CObRefrRecord::GetFieldBaseEditorID,	NULL,				&CObRefrRecord::CompareFieldBaseEditorID)
	ADD_OBFIELDMAP("BaseName",	 OB_FIELD_BASENAME,	  0, &CObRefrRecord::GetFieldBaseName,		NULL,				NULL)
END_OBFIELDMAP()
/*===========================================================================
 *		End of CObRefrRecord Field Map
 *=========================================================================*/


/*===========================================================================
 *
 * Class CObRefrRecord Constructor
 *
 *=========================================================================*/
CObRefrRecord::CObRefrRecord () {
  m_pItemName   = NULL;
  m_pData       = NULL;
  m_pTeleport   = NULL;
  m_pMarkerType = NULL;
  m_pName       = NULL;
 }
/*===========================================================================
 *		End of Class CObRefrRecord Constructor
 *=========================================================================*/


/*===========================================================================
 *
 * Class CObRefrRecord Method - void Destroy (void);
 *
 *=========================================================================*/
void CObRefrRecord::Destroy (void) {
  m_pItemName   = NULL;
  m_pData       = NULL;
  m_pTeleport   = NULL;
  m_pMarkerType = NULL;
  m_pName       = NULL;

  CObIdRecord::Destroy();
 }
/*===========================================================================
 *		End of Class Method CObRefrRecord::Destroy()
 *=========================================================================*/


/*===========================================================================
 *
 * Class CObRefrRecord Method - void InitializeNew (void);
 *
 *=========================================================================*/
void CObRefrRecord::InitializeNew (void) {

	/* Call the base class method first */
  CObIdRecord::InitializeNew();

  AddNewSubrecord(OB_NAME_NAME);
  if (m_pName != NULL) m_pName->InitializeNew();

	/* Create a new item name subrecords if required */
  if (HasFullItemName()) {
    AddNewSubrecord(OB_NAME_FULL);
    if (m_pItemName != NULL) m_pItemName->InitializeNew();
   }

  AddNewSubrecord(OB_NAME_DATA);
  if (m_pData != NULL) m_pData->InitializeNew();

 }
/*===========================================================================
 *		End of Class Method CObRefrRecord::InitializeNew()
 *=========================================================================*/


/*===========================================================================
 *
 * Class CObRefrRecord Method - bool IsActor (void);
 *
 *=========================================================================*/
bool CObRefrRecord::IsActor (void) {
  CObRecord* pRecord;

  if (m_pName == NULL || m_pParent == NULL) return (false);

  pRecord = m_pParent->FindFormID(m_pName->GetValue());
  if (pRecord == NULL) return (false);

  if (pRecord->GetRecordType() == OB_NAME_NPC_ || pRecord->GetRecordType() == OB_NAME_CREA || pRecord->GetRecordType() == OB_NAME_LVLC) return (true);
  return (false);
}
/*===========================================================================
 *		End of Class Method CObRefrRecord::IsActor()
 *=========================================================================*/


/*===========================================================================
 *
 * Class CObRefrRecord Method - bool IsFormType (Type);
 *
 *=========================================================================*/
bool CObRefrRecord::IsFormType (const int Type) {

	/* Test against known simple types */
  switch (Type) {
    case OB_FUNCPARAM_MAPMARKER:
        return IsMapMarker();
    case OB_FUNCPARAM_ACTOR:
	return IsActor();
  }

	/* Default */
  return CObIdRecord::IsFormType(Type);
}
/*===========================================================================
 *		End of Class Method CObRefrRecord::IsFormType()
 *=========================================================================*/


/*===========================================================================
 *
 * Class CObRefrRecord Event - void OnAddSubrecord (pSubrecord);
 *
 *=========================================================================*/
void CObRefrRecord::OnAddSubrecord (CObSubrecord* pSubrecord) {

  if (pSubrecord->GetRecordType() == OB_NAME_FULL) {
   m_pItemName = ObCastClass(CObFullSubrecord, pSubrecord);
  }
  else if (pSubrecord->GetRecordType() == OB_NAME_DATA) {
   m_pData = ObCastClass(CObRefrDataSubrecord, pSubrecord);
   TEST_INTVALUE1(pSubrecord->GetRecordSize(), OB_REFRDATA_SUBRECORD_SIZE, OB_NAME_DATA);
  }
  else if (pSubrecord->GetRecordType() == OB_NAME_NAME) {
   m_pName = ObCastClass(CObFormidSubrecord, pSubrecord);
  }
  else if (pSubrecord->GetRecordType() == OB_NAME_XTEL) {
   m_pTeleport = ObCastClass(CObXtelSubrecord, pSubrecord);
   TEST_INTVALUE1(pSubrecord->GetRecordSize(), OB_XTEL_SUBRECORD_SIZE, OB_NAME_XTEL);
  }
  else if (pSubrecord->GetRecordType() == OB_NAME_TNAM) {
   m_pMarkerType = ObCastClass(CObWordSubrecord, pSubrecord);
   TEST_INTVALUE1(pSubrecord->GetRecordSize(), 2, OB_NAME_TNAM);
  }
  else {
    CObIdRecord::OnAddSubrecord(pSubrecord);
  }

 }
/*===========================================================================
 *		End of Class Event CObRefrRecord::OnAddSubRecord()
 *=========================================================================*/


/*===========================================================================
 *
 * Class CObRefrRecord Event - void OnDeleteSubrecord (pSubrecord);
 *
 *=========================================================================*/
void CObRefrRecord::OnDeleteSubrecord (CObSubrecord* pSubrecord) {

  if (m_pItemName == pSubrecord) {
    m_pItemName = NULL;
  }
  else if (m_pData == pSubrecord) {
    m_pData = NULL;
  }
  else if (m_pName == pSubrecord) {
    m_pName = NULL;
  }
  else if (m_pTeleport == pSubrecord) {
    m_pTeleport = NULL;
  }
  else if (m_pMarkerType == pSubrecord) {
    m_pMarkerType = NULL;
  }
  else {
    CObIdRecord::OnDeleteSubrecord(pSubrecord);
  }

}
/*===========================================================================
 *		End of Class Event CObRefrRecord::OnDeleteSubrecord()
 *=========================================================================*/


/*===========================================================================
 *
 * Class CObRefrRecord Method - void SetBaseFormID (FormID);
 *
 *=========================================================================*/
void CObRefrRecord::SetBaseFormID (const obformid_t FormID) {

  if (m_pName == NULL) {
    AddNewSubrecord(OB_NAME_NAME);
    if (m_pName == NULL) return;
    m_pName->InitializeNew();
  }

  m_pName->SetValue(FormID);
}
/*===========================================================================
 *		End of Class Method CObRefrRecord::SetBaseFormID()
 *=========================================================================*/


/*===========================================================================
 *
 * Class CObRefrRecord Method - void SetItemName (pString);
 *
 *=========================================================================*/
void CObRefrRecord::SetItemName (const SSCHAR* pString) {

  if (m_pItemName == NULL) {
     AddNewSubrecord(OB_NAME_FULL);
     if (m_pItemName == NULL) return;
     m_pItemName->InitializeNew();
  }

  m_pItemName->SetString(pString);
}
/*===========================================================================
 *		End of Class Method CObRefrRecord::SetItemName()
 *=========================================================================*/


/*===========================================================================
 *
 * Begin CObRefrRecord Get Field Methods
 *
 *=========================================================================*/
DEFINE_OBGETFIELD(CObRefrRecord::GetFieldBaseFormID, String.Format("0x%08X", GetBaseFormID()))
DEFINE_OBGETFIELD(CObRefrRecord::GetFieldItemName, String.Format("%s", GetItemName()))
DEFINE_OBGETFIELD(CObRefrRecord::GetFieldLocationX, String.Format("%g", GetLocationX()))
DEFINE_OBGETFIELD(CObRefrRecord::GetFieldLocationY, String.Format("%g", GetLocationY()))
DEFINE_OBGETFIELD(CObRefrRecord::GetFieldLocationZ, String.Format("%g", GetLocationZ()))
DEFINE_OBGETFIELD(CObRefrRecord::GetFieldAngleX, String.Format("%g", GetAngleX()))
DEFINE_OBGETFIELD(CObRefrRecord::GetFieldAngleY, String.Format("%g", GetAngleY()))
DEFINE_OBGETFIELD(CObRefrRecord::GetFieldAngleZ, String.Format("%g", GetAngleZ()))
DEFINE_OBGETFIELD(CObRefrRecord::GetFieldTeleportFormID, String.Format("0x%08X", GetTeleportFormID()))
DEFINE_OBGETFIELD(CObRefrRecord::GetFieldTeleportLocX, String.Format("%g", GetTeleportLocX()))
DEFINE_OBGETFIELD(CObRefrRecord::GetFieldTeleportLocY, String.Format("%g", GetTeleportLocY()))
DEFINE_OBGETFIELD(CObRefrRecord::GetFieldTeleportLocZ, String.Format("%g", GetTeleportLocZ()))
DEFINE_OBGETFIELD(CObRefrRecord::GetFieldTeleportAngleX, String.Format("%g", GetTeleportAngleX()))
DEFINE_OBGETFIELD(CObRefrRecord::GetFieldTeleportAngleY, String.Format("%g", GetTeleportAngleY()))
DEFINE_OBGETFIELD(CObRefrRecord::GetFieldTeleportAngleZ, String.Format("%g", GetTeleportAngleZ()))

BEGIN_OBGETFIELD(CObRefrRecord::GetFieldBaseEditorID)
	if (m_pParent != NULL) return m_pParent->GetEditorID(String, GetBaseFormID());
        String.Format("0x%08X", GetBaseFormID());
END_OBGETFIELD()

BEGIN_OBGETFIELD(CObRefrRecord::GetFieldBaseName)
	CObBaseRecord* pBaseRecord = NULL;
	CObRecord*     pRecord = NULL;
	CObSubrecord*  pName = NULL;

	if (m_pParent   != NULL) pBaseRecord = m_pParent->FindFormID(GetBaseFormID());
	if (pBaseRecord != NULL) pRecord     = ObCastClass(CObRecord, pBaseRecord);
	if (pRecord     != NULL) pName       = pRecord->FindSubrecord(OB_NAME_FULL);

	if (pName != NULL) {
		String.Format("%s", pName->GetData());
	}
	else {
		String.Format("0x%08X", GetBaseFormID());
		return (true);
	}
END_OBGETFIELD()

BEGIN_OBGETFIELD(CObRefrRecord::GetFieldMarkerTypeID)
	if (!IsMapMarker()) {
	  String = "(null)";
	}
	else {
	  String.Format("%d", GetMarkerType());
	}
END_OBGETFIELD()

BEGIN_OBGETFIELD(CObRefrRecord::GetFieldMarkerType)
	if (!IsMapMarker()) {
	  String.Empty();
	}
	else {
	  String.Format("%s", GetObMapMarkerTypeString(GetMarkerType()));
	}
END_OBGETFIELD()

BEGIN_OBGETFIELD(CObRefrRecord::GetFieldTeleportName)
	CObBaseRecord*  pRecord;
	CObFormIDGroup* pGroup = NULL;
	CObCellRecord*  pCell  = NULL;
	obformid_t      FormID = GetTeleportFormID();
	obformid_t	CellFormID;
	
	if (FormID == OB_FORMID_NULL) {
	  String.Empty();
	  return (true);
	 }
	else if (m_pParent != NULL) {
	  pRecord = m_pParent->FindFormID(FormID);
	  if (pRecord != NULL && pRecord->GetParentGroup() != NULL) pGroup = ObCastClass(CObFormIDGroup, pRecord->GetParentGroup());
	 }

	if (pGroup != NULL) {
	  CellFormID = pGroup->GetParentFormID();
	  pRecord = m_pParent->FindFormID(CellFormID);
	  if (pRecord != NULL) pCell = ObCastClass(CObCellRecord, pRecord);
	}

	if (pCell == NULL) {
	  String.Format("0x08%X", CellFormID);
	  return (true);
	}

	const SSCHAR* pString = pCell->GetCellName();

	if (pString == NULL || pString[0] == NULL_CHAR) {
	  pString = pCell->GetEditorID(); 
	  if (pString == NULL) pString = "";
	}

	String.Format("%s", pString);
END_OBGETFIELD()


BEGIN_OBGETFIELD(CObRefrRecord::GetFieldWorldSpace)
	CObGroup*       pGroup;
	CObBaseRecord*  pRecord = NULL;
	CObWrldRecord*  pWorld  = NULL;
	
	pGroup = GetParentGroup();
	
	while (pGroup != NULL) {
	  if (pGroup->GetType() == OB_GROUP_WORLDCHILD) break;
	  pGroup = pGroup->GetParentGroup();
	}

	if (pGroup != NULL) {
	  obformid_t FormID = pGroup->GetHeader().Data.ParentFormID;

	  if (m_pParent != NULL) {
	    pRecord = m_pParent->FindFormID(FormID);
	    if (pRecord != NULL) pWorld = ObCastClass(CObWrldRecord, pRecord);
	  }

          if (pWorld == NULL)
	    String.Format("0x%08X", FormID);
	  else {
	    const SSCHAR* pString = pWorld->GetFullName();
	    if (pString[0] == NULL_CHAR) pString = pWorld->GetEditorID();
	    String.Format("%s", pString);
	  }
	}
END_OBGETFIELD()
/*===========================================================================
 *		End of CObRefrRecord Get Field Methods
 *=========================================================================*/


/*===========================================================================
 *
 * Begin CObRefrRecord Compare Field Methods
 *
 *=========================================================================*/
DEFINE_OBCOMPFIELDDWORD(CObRefrRecord, CompareFieldBaseFormID, GetBaseFormID)
DEFINE_OBCOMPFIELDEDITORID(CObRefrRecord, CompareFieldBaseEditorID, GetBaseFormID)
DEFINE_OBCOMPFIELDSTRING(CObRefrRecord, CompareFieldItemName, GetItemName)
DEFINE_OBCOMPFIELDFLOAT(CObRefrRecord, CompareFieldLocationX, GetLocationX, 100.0f)
DEFINE_OBCOMPFIELDFLOAT(CObRefrRecord, CompareFieldLocationY, GetLocationY, 100.0f)
DEFINE_OBCOMPFIELDFLOAT(CObRefrRecord, CompareFieldLocationZ, GetLocationZ, 100.0f)
DEFINE_OBCOMPFIELDFLOAT(CObRefrRecord, CompareFieldAngleX, GetAngleX, 100.0f)
DEFINE_OBCOMPFIELDFLOAT(CObRefrRecord, CompareFieldAngleY, GetAngleY, 100.0f)
DEFINE_OBCOMPFIELDFLOAT(CObRefrRecord, CompareFieldAngleZ, GetAngleZ, 100.0f)
DEFINE_OBCOMPFIELDDWORD(CObRefrRecord, CompareFieldTeleportFormID, GetTeleportFormID)
DEFINE_OBCOMPFIELDFLOAT(CObRefrRecord, CompareFieldTeleportLocX, GetTeleportLocX, 100.0f)
DEFINE_OBCOMPFIELDFLOAT(CObRefrRecord, CompareFieldTeleportLocY, GetTeleportLocY, 100.0f)
DEFINE_OBCOMPFIELDFLOAT(CObRefrRecord, CompareFieldTeleportLocZ, GetTeleportLocZ, 100.0f)
DEFINE_OBCOMPFIELDFLOAT(CObRefrRecord, CompareFieldTeleportAngleX, GetTeleportAngleX, 100.0f)
DEFINE_OBCOMPFIELDFLOAT(CObRefrRecord, CompareFieldTeleportAngleY, GetTeleportAngleY, 100.0f)
DEFINE_OBCOMPFIELDFLOAT(CObRefrRecord, CompareFieldTeleportAngleZ, GetTeleportAngleZ, 100.0f)
DEFINE_OBCOMPFIELDDWORD(CObRefrRecord, CompareFieldMarkerType, GetMarkerType)
DEFINE_OBCOMPFIELDDWORD(CObRefrRecord, CompareFieldMarkerTypeID, GetMarkerType)
/*===========================================================================
 *		End of CObRefrRecord Compare Field Methods
 *=========================================================================*/


/*===========================================================================
 *
 * Begin CObRefrRecord Set Field Methods
 *
 *=========================================================================*/
BEGIN_OBSETFIELD(CObRefrRecord::SetFieldItemName)
  SetItemName(pString);
END_OBSETFIELD()
/*===========================================================================
 *		End of CObRefrRecord Set Field Methods
 *=========================================================================*/

